const Jimp = require('jimp');

// 需要添加的水印图片路径
// const ORIGINAL_IMAGE = './img/test.png';
const ORIGINAL_IMAGE = './img/test.jpg';

// 水印logo路径
const LOGO = './img/logo.png';

// 水印距离右下角百分比
const LOGO_MARGIN_PERCENTAGE = 5 / 100;

const main = async () => {
  const [image, logo] = await Promise.all([
    Jimp.read(ORIGINAL_IMAGE),
    Jimp.read(LOGO)
  ]);

  // 将 logo 等比缩小 10 倍
  // logo.resize(logo.width / 10, Jimp.AUTO);

  const xMargin = image.bitmap.width * LOGO_MARGIN_PERCENTAGE;
  const yMargin = image.bitmap.width * LOGO_MARGIN_PERCENTAGE;

  const X = image.bitmap.width - logo.bitmap.width - xMargin;
  const Y = image.bitmap.height - logo.bitmap.height - yMargin;

  return image.composite(logo, X, Y, [
    {
      mode: Jimp.BLEND_SOURCE_OVER,
      opacitySource: 0.1,
      opacityDest: 1
    }
  ]);
};

main().then(image => {
  const FILENAME = 'new_name.' + image.getExtension();

  // 压缩图片 0-100
  image.quality(80);

  return image.write(FILENAME, (err) => {
    if (err) {
      return console.error(err);
    };
    console.log('水印成功：', FILENAME);
  });
});
